import 'package:hakk_builder/hakk_builder.dart';

main(){
  print(
    hakk('Medusa', (){
      blocks((){
        B.memory('mem2', 1, 0);
        B.memory('mem3', -1, 1);
        B.memory('mem4', 1, 1);
        B.memory('mem5', 0, 1);
        B.memory('mousemem', -1, 0);
        B.instruction('mouse', 0, 2);
        B.subHakkPort('shp1', 0, -2, 'sh1', (){
          B.shpBlock('mouse', 0, -1);
          B.shpBlock('mousemem', 0, -2);
        });
        B.subHakkPort('shp2', 0, -2, 'sh2', (){
          B.shpBlock('mouse', 0, -1);
          B.shpBlock('mousemem', 0, -2);
        });
        B.subHakkPort('shp3', 0, -2, 'sh3', (){
          B.shpBlock('mouse', 0, -1);
          B.shpBlock('mousemem', 0, -2);
        });
      });

      code((){
        codeBlock('mouse', (){
          I.rnd('mousemem.0', 100);
          I.jl('mousemem.0', 40, 'movef');
          I.jl('mousemem.0', 60, 'turnl');
          I.jl('mousemem.0', 80, 'turnr');
          I.goto('moveb');
          I.lbl('movef');
          I.rem('reading and writing from the main Hakk core memory');
          I.movef(core(7));
          I.movef(core(7));
          I.movef(core(7));
          I.goto('mouse');
          I.lbl('turnl');
          I.turn(core(6), 1);
          I.goto('mouse');
          I.lbl('turnr');
          I.turn(core(6), 0);
          I.goto('mouse');
          I.lbl('moveb');
          I.moveb(core(6));
          I.goto('mouse');
        });
        codeBlock('core', (){
          I.shpl(core(5), 'shp1');
          I.shpl(core(5), 'shp2');
          I.shpl(core(5), 'shp3');
          I.lbl('top');
          I.movef(core(0));
          I.je(core(0), 1, 'top');
          I.rem('move failed. move back a few spaces and change course');
          I.moveb(core(1));
          I.moveb(core(1));
          I.moveb(core(1));
          I.rnd(core(2), 2);
          I.rem('store the 0 or 1 in core.2 and then use it to change direction');
          I.turn(core(3), core(2));
          I.goto('top');
        });
      });
    })
  );
}